<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblTipoUsuarioRepository;

final class TblTipoUsuarioService
{
    private TblTipoUsuarioRepository $TblTipoUsuarioRepository;

    public function __construct(TblTipoUsuarioRepository $TblTipoUsuarioRepository)
    {
        $this->TblTipoUsuarioRepository = $TblTipoUsuarioRepository;
    }

    public function checkAndGet(int $TblTipoUsuarioId): object
    {
        return $this->TblTipoUsuarioRepository->checkAndGet($TblTipoUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblTipoUsuarioRepository->getAll();
    }

    public function getOne(int $TblTipoUsuarioId): object
    {
        return $this->checkAndGet($TblTipoUsuarioId);
    }

    public function create(array $input): object
    {
        $TblTipoUsuario = json_decode((string) json_encode($input), false);

        return $this->TblTipoUsuarioRepository->create($TblTipoUsuario);
    }

    public function update(array $input, int $TblTipoUsuarioId): object
    {
        $TblTipoUsuario = $this->checkAndGet($TblTipoUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblTipoUsuarioRepository->update($TblTipoUsuario, $data);
    }

    public function delete(int $TblTipoUsuarioId): void
    {
        $this->checkAndGet($TblTipoUsuarioId);
        $this->TblTipoUsuarioRepository->delete($TblTipoUsuarioId);
    }
}
